<?php
/**
	Url routing tutorial
**/


$url = explode ('/',trim(substr($_SERVER['REQUEST_URI'],strlen(preg_replace('/(.*)\/.+/','$1',$_SERVER['SCRIPT_NAME']))),' /'));
$routes = array();
$args = array();

route('test/:arg1',function($arg1='default') {
	echo 'called test'.$arg1;
});
route('test1',function() {
	echo 'called test1';
});
route('test2',function() {
	echo 'called test2';
});

run();

	function route($pattern, $funcs) {
		global $routes;
		// Valid functions
		if (is_string($funcs)) {
			// String passed
			foreach (explode('|',$funcs) as $func) {
				// Not a lambda function
				if (substr_count($func,'.php')!=0) {
					// Run external PHP script
					$file = strstr($func,'.php',TRUE).'.php';
					if (!is_file($file)) {
						// Invalid route handler
						trigger_error($file." is not a valid file");
						return;
					}
				} 
				elseif (!is_callable($func)) {
					// Invalid route handler
					trigger_error($func.' is not a valid function');
					return;
				}
			}
		}
		elseif (!is_callable($funcs)) {
			// Invalid function
			trigger_error($func.' is not a valid function');
			return;
		}
		
		$routes[$pattern] = $funcs;
	}
	
	function matches($route) {
		global $url,$args;
		$pattern = $route;

		$route = explode('/',$route);
		$i = 0;
		
		while (isset($route[$i]) && isset($url[$i])) {
			if ($route[$i]=='*') {
				return true;
			}
			elseif ($route[$i][0]==':') {
				$args[$pattern][] = $url[$i];
				$i++;
			}
			elseif ($route[$i] == $url[$i]) {
				$i++;
			}
			else {
				unset($args[$pattern]);
				return false;
			}
		}	
		if (isset($route[$i])==isset($url[$i])) {
		return true;
		}
		elseif (!isset($url[$i]) && $route[$i]=='*') {
			return true;
		}
		else {
			unset($args[$pattern]);
			return false;
		}
	}
	
	function run() {
		global $routes,$url,$args;
		$allroutes = array_keys($routes);
		// Process routes
		if (!isset($allroutes)) {
			trigger_error('No routes set!');
			return;
		}
		
		$found=FALSE;
		
		$valid_routes = array();
		// Search recursively the depth to which an identical route is defined 
		foreach ($allroutes as $route) {
			if (matches($route)) {
				$valid_routes [] = $route;
			}
		}
		rsort($valid_routes);
		$args = array_unique($args);

		if (!empty($valid_routes)) {
				$found=TRUE;
		}
		
		if (!$found) {
			trigger_error('Page not found!');
		}
		else {
		
		if (!isset($args[$valid_routes[0]])) {
			$args[$valid_routes[0]] = array();
		}
		//Remaining part of URL is passed to functions as arguments
		call($routes[$valid_routes[0]],$args[$valid_routes[0]]);
	
		return;
		}
	}

	function call($funcs,$args) {
		if (!is_array($args)) {
			$args=array($args);
		}
		if (is_string($funcs)) {
			// Call each code segment
			foreach (explode('|',$funcs) as $func) {
				if (substr_count($func,'.php')!=0) {
					// Run external PHP script
					$file = strstr($func,'.php',TRUE).'.php';
					$functions = substr(strstr($func,'.php'),5);
					
					include $file;
					$functions = explode(':',$functions);
					foreach ($functions as $function) {
						if (!is_callable($function)) {
							// Invalid route handler
							trigger_error($function.' is not a valid function');
							return;
						}
						call_user_func_array($function,$args);
					}
				} 
				else {
					// Call lambda function
					call_user_func_array($func,$args);
				}
			}
		}
		else
			// Call lambda function
			call_user_func_array($funcs,$args);
	}
?>